petsc-3.7.1 2016-05-15
Report Typos and Errors

# PetscAttachDebuggerErrorHandler

Error handler that attaches a debugger to a running process when an error is detected. This routine is useful for examining variables, etc.

### Synopsis

    #include "petscsys.h"
    PetscErrorCode  PetscAttachDebuggerErrorHandler(MPI_Comm comm,int line,const char *fun,const char *file,PetscErrorCode num,PetscErrorType p,const char *mess,void *ctx)

Not Collective Many br

### Input Parameters

| comm | - communicator over which error occurred Many br
| line | - the line number of the error (indicated by __LINE__) Many br
| fun | - function where error occured (indicated by __FUNCT__) Many br
| file | - the file in which the error was detected (indicated by __FILE__) Many br
| message | - an error text string, usually just printed to the screen Many br
| number | - the generic error number Many br
| p | - PETSC_ERROR_INITIAL if error just detected, otherwise PETSC_ERROR_REPEAT Many br
| ctx | - error handler context Many br

### Options Database Keys

-on_error_attach_debugger [noxterm,dbx,xxgdb,xdb,xldb,gdb] [ -display name] - Activates Many brdebugger attachment Many br

Many br

### Notes

By default the GNU debugger, gdb, is used. Alternatives are lldb, dbx and Many brxxgdb,xldb (on IBM rs6000), xdb (on HP-UX). Many br

Most users need not directly employ this routine and the other error Many brhandlers, but can instead use the simplified interface SETERR, which has Many brthe calling sequence Many br

        SETERRQ(PETSC_COMM_SELF,number,p,message)

### Notes for experienced users

Use PetscPushErrorHandler() to set the desired error handler. The Many brcurrently available PETSc error handlers are Many br

       PetscTraceBackErrorHandler()

       PetscAttachDebuggerErrorHandler()

       PetscAbortErrorHandler()

or you may write your own. Many br

### See Also

PetscPushErrorHandler(), PetscTraceBackErrorHandler(),
PetscAbortErrorHandler() Many br

Level:developer
Location:src/sys/error/adebug.c
Index of all Sys routines
Table of Contents for all manual pages
Index of all manual pages